﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Charting;
using Telerik.Windows.Controls;

namespace SilverlightApplication11
{
    public partial class Sampling : UserControl
    {
        public Sampling()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(Sampling_Loaded);
        }

        void Sampling_Loaded(object sender, RoutedEventArgs e)
        {
            this.SetMappings(RadChart1);
            RadChart1.SamplingSettings.SamplingThreshold = 300;
            RadChart1.DefaultView.ChartArea.ZoomScrollSettingsX.MinZoomRange = 0.0000005;
            RadChart1.DefaultView.ChartArea.AxisX.LabelRotationAngle = 60;
            RadChart1.DefaultView.ChartArea.AxisX.DefaultLabelFormat = "yyyy-MMM-dd hh:mm:ss.ff";

            RadChart1.DefaultView.ChartArea.ZoomScrollSettingsX.ScrollMode = ScrollMode.ScrollAndZoom;
            RadChart1.ItemsSource = MyObject.GetList();
        }

        private void SetMappings(RadChart chart)
        {
            SeriesMapping seriesMapping = new SeriesMapping();
            seriesMapping.SeriesDefinition = new LineSeriesDefinition() { ShowItemLabels = false, ShowPointMarks=false,  ShowItemToolTips = false};
            seriesMapping.ItemMappings.Add(new ItemMapping("Value", DataPointMember.YValue));
            seriesMapping.ItemMappings.Add(new ItemMapping("Date", DataPointMember.XValue));
            chart.SeriesMappings.Add(seriesMapping);
        }
    }

    public class MyObject
    {
        public DateTime Date { get; set; }
        public double Value{ get; set; }

        public static List<MyObject> GetList()
        {
            Random r = new Random();
            List<MyObject> result = new List<MyObject>();
            for (int i = 0; i < 2000000; i++)
                result.Add(new MyObject() { Date = DateTime.Today.AddSeconds(i*0.5), Value = r.Next(100) });
            
            return result;
        }
    }
}
